QCPAxisTickerText Class Reference
Author: Emanuel Eichhammer

· · · ·
Public Functions | Protected Functions
QCPAxisTickerText Class Reference

Specialized axis ticker which allows arbitrary labels at specified coordinates. More...

Inheritance diagram for QCPAxisTickerText:

## Public Functions
| QCPAxisTickerText ()
QMap< double, QString > & | ticks ()
int | subTickCount () const
void | setTicks (const QMap< double, QString > &ticks)
void | setTicks (const QVector< double > &positions, const QVector< QString > &labels)
void | setSubTickCount (int subTicks)
void | clear ()
void | addTick (double position, const QString &label)
void | addTicks (const QMap< double, QString > &ticks)
void | addTicks (const QVector< double > &positions, const QVector< QString > &labels)
Public Functions inherited from QCPAxisTicker
| QCPAxisTicker ()
TickStepStrategy | tickStepStrategy () const
int | tickCount () const
double | tickOrigin () const
void | setTickStepStrategy (TickStepStrategy strategy)
void | setTickCount (int count)
void | setTickOrigin (double origin)
virtual void | generate (const QCPRange &range, const QLocale &locale, QChar formatChar, int precision, QVector< double > &ticks, QVector< double > *subTicks, QVector< QString > *tickLabels)

## Protected Functions
virtual double | getTickStep (const QCPRange &range)
virtual int | getSubTickCount (double tickStep)
virtual QString | getTickLabel (double tick, const QLocale &locale, QChar formatChar, int precision)
virtual QVector< double > | createTickVector (double tickStep, const QCPRange &range)
Protected Functions inherited from QCPAxisTicker
virtual QVector< double > | createSubTickVector (int subTickCount, const QVector< double > &ticks)
virtual QVector< QString > | createLabelVector (const QVector< double > &ticks, const QLocale &locale, QChar formatChar, int precision)
void | trimTicks (const QCPRange &range, QVector< double > &ticks, bool keepOneOutlier) const
double | pickClosest (double target, const QVector< double > &candidates) const
double | getMantissa (double input, double *magnitude=nullptr) const
double | cleanMantissa (double input) const

## Additional Inherited Members
Public Types inherited from QCPAxisTicker
enum | TickStepStrategy

## Detailed Description

Specialized axis ticker which allows arbitrary labels at specified coordinates.

This QCPAxisTicker subclass generates ticks which can be directly specified by the user as coordinates and associated strings. They can be passed as a whole with setTicks or one at a time with addTick. Alternatively you can directly access the internal storage via ticks and modify the tick/label data there.

This is useful for cases where the axis represents categories rather than numerical values.

If you are updating the ticks of this ticker regularly and in a dynamic fasion (e.g. dependent on the axis range), it is a sign that you should probably create an own ticker by subclassing QCPAxisTicker, instead of using this one.

The ticker can be created and assigned to an axis like this:

QSharedPointer<QCPAxisTickerText> textTicker(new QCPAxisTickerText);
customPlot->xAxis->setTicker(textTicker);
textTicker->addTick(1.0, "Bacteria");
textTicker->addTick(2.0, "Protozoa");
textTicker->addTick(3.0, "Chromista");
textTicker->addTick(4.0, "Plants");
textTicker->addTick(5.0, "Fungi");
textTicker->addTick(6.0, "Animals");
textTicker->addTick(8.0, "Vogons");

## Constructor & Destructor Documentation

## § QCPAxisTickerText()

QCPAxisTickerText::QCPAxisTickerText | ( |  | ) |

Constructs the ticker and sets reasonable default values. Axis tickers are commonly created managed by a QSharedPointer, which then can be passed to QCPAxis::setTicker.

## Member Function Documentation

## § ticks()

QMap< double, QString > & QCPAxisTickerText::ticks | ( |  | ) |
| inline

Returns a non-const reference to the internal map which stores the tick coordinates and their labels.

You can access the map directly in order to add, remove or manipulate ticks, as an alternative to using the methods provided by QCPAxisTickerText, such as setTicks and addTick.

## § setTicks() [1/2]

void QCPAxisTickerText::setTicks | ( | const QMap< double, QString > & | ticks | ) |

This is an overloaded function.

Sets the ticks that shall appear on the axis. The map key of ticks corresponds to the axis coordinate, and the map value is the string that will appear as tick label.

An alternative to manipulate ticks is to directly access the internal storage with the ticks getter.

See also
  addTicks, addTick, clear

## § setTicks() [2/2]

void QCPAxisTickerText::setTicks | ( | const QVector< double > & | positions,
|  | const QVector< QString > & | labels
| ) |  |

This is an overloaded function.

Sets the ticks that shall appear on the axis. The entries of positions correspond to the axis coordinates, and the entries of labels are the respective strings that will appear as tick labels.

See also
  addTicks, addTick, clear

## § setSubTickCount()

void QCPAxisTickerText::setSubTickCount | ( | int | subTicks | ) |

Sets the number of sub ticks that shall appear between ticks. For QCPAxisTickerText, there is no automatic sub tick count calculation. So if sub ticks are needed, they must be configured with this method.

## § clear()

void QCPAxisTickerText::clear | ( |  | ) |

Clears all ticks.

An alternative to manipulate ticks is to directly access the internal storage with the ticks getter.

See also
  setTicks, addTicks, addTick

## § addTick()

void QCPAxisTickerText::addTick | ( | double | position,
|  | const QString & | label
| ) |  |

Adds a single tick to the axis at the given axis coordinate position, with the provided tick label.

See also
  addTicks, setTicks, clear

## § addTicks() [1/2]

void QCPAxisTickerText::addTicks | ( | const QMap< double, QString > & | ticks | ) |

This is an overloaded function.

Adds the provided ticks to the ones already existing. The map key of ticks corresponds to the axis coordinate, and the map value is the string that will appear as tick label.

An alternative to manipulate ticks is to directly access the internal storage with the ticks getter.

See also
  addTick, setTicks, clear

## § addTicks() [2/2]

void QCPAxisTickerText::addTicks | ( | const QVector< double > & | positions,
|  | const QVector< QString > & | labels
| ) |  |

This is an overloaded function.

Adds the provided ticks to the ones already existing. The entries of positions correspond to the axis coordinates, and the entries of labels are the respective strings that will appear as tick labels.

An alternative to manipulate ticks is to directly access the internal storage with the ticks getter.

See also
  addTick, setTicks, clear

## § getTickStep()

double QCPAxisTickerText::getTickStep | ( | const QCPRange & | range | ) |
| protectedvirtual

Since the tick coordinates are provided externally, this method implementation does nothing.

For general information about this virtual method, see the base class implementation.

Reimplemented from QCPAxisTicker.

## § getSubTickCount()

int QCPAxisTickerText::getSubTickCount | ( | double | tickStep | ) |
| protectedvirtual

Returns the sub tick count that was configured with setSubTickCount.

For general information about this virtual method, see the base class implementation.

Reimplemented from QCPAxisTicker.

## § getTickLabel()

QString QCPAxisTickerText::getTickLabel | ( | double | tick,
|  | const QLocale & | locale,
|  | QChar | formatChar,
|  | int | precision
| ) |  |
| protectedvirtual

Returns the tick label which corresponds to the key tick in the internal tick storage. Since the labels are provided externally, locale, formatChar, and precision are ignored.

For general information about this virtual method, see the base class implementation.

Reimplemented from QCPAxisTicker.

## § createTickVector()

QVector< double > QCPAxisTickerText::createTickVector | ( | double | tickStep,
|  | const QCPRange & | range
| ) |  |
| protectedvirtual

Returns the externally provided tick coordinates which are in the specified range. If available, one tick above and below the range is provided in addition, to allow possible sub tick calculation. The parameter tickStep is ignored.

For general information about this virtual method, see the base class implementation.

Reimplemented from QCPAxisTicker.

The documentation for this class was generated from the following files:

- src/axis/axistickertext.h
- src/axis/axistickertext.cpp